// WideDisplaySample.cpp
//
// This file contains the macro which includes the PilotMain
// entry point for the application.

// Entry point file
#include "Common.h"
#include "WideDisplaySampleApp.h"

// Entry point
//DEFAULT_STARTER(CWideDisplaySampleApp)

void RegisterNotify( );
void UnregisterNotify( );


UInt32 PilotMain( UInt16 wCommand, MemPtr pCommandParameters, UInt16 wLaunchFlags ) {

	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	if( wCommand == sysAppLaunchCmdNotify ) {
		SysNotifyParamType* pNotifyParams = static_cast<SysNotifyParamType*>( pCommandParameters );
		if( pNotifyParams->notifyType == sysNotifyDisplayResizedEvent ) {
			EventType resizedEvent;
			::MemSet( &resizedEvent, sizeof(EventType), 0 );
			resizedEvent.eType = static_cast<eventsEnum>( winDisplayChangedEvent );
			::EvtAddUniqueEventToQueue( &resizedEvent, 0, true );
		}
		return errNone;
	}
	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

	TRACE_INIT();

	CWideDisplaySampleApp palmApp;
	palmApp.m_wCommand = wCommand;
	palmApp.m_pCommandParameters = pCommandParameters;
	palmApp.m_wLaunchFlags = wLaunchFlags;
	
	RegisterNotify( );
	Err error = palmApp.AppStart( );
	if( error == errNone ) {
		palmApp.EventLoop( );
		error = palmApp.AppStop( );
	}
	UnregisterNotify( );
	TRACE_DONE();
	
	return error;

}


void RegisterNotify( ) {
	UInt16	cardNo;
	LocalID	dbID;
	SysCurAppDatabase( &cardNo, &dbID );
	::SysNotifyRegister( cardNo, dbID, sysNotifyDisplayResizedEvent,
										NULL, sysNotifyNormalPriority, 0 );
}

void UnregisterNotify( ) {
	UInt16	cardNo;
	LocalID	dbID;
	SysCurAppDatabase( &cardNo, &dbID );
	::SysNotifyUnregister( cardNo, dbID,
							sysNotifyDisplayResizedEvent, sysNotifyNormalPriority ); 
}
